<?php

namespace App\Dto\Input;

use ApiPlatform\Metadata\ApiProperty;
use App\Dto\Output\ImageOutput;
use App\Dto\Output\ImageRepositoryOutput;
use App\Entity\ImageImageRepository;
use App\Entity\PxeTemplate;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Validator\Constraints as Assert;

final class ImageImageRepositoryInput
{
    #[Assert\NotNull]
    #[Groups(['image-image-repository:write'])]
    public ?ImageRepositoryOutput $imageRepository = null;

    #[Assert\NotNull]
    #[Groups(['image-image-repository:write'])]
    public ?string $status = '';

    public function __construct(?ImageImageRepository $imageImageRepository = null)
    {
        if (!$imageImageRepository) {
            return;
        }

        $this->imageRepository = new ImageRepositoryOutput($imageImageRepository->getRepository());
        $this->status = $imageImageRepository->getStatus();
    }

    public function createOrUpdateEntity(?ImageImageRepository $imageImageRepository = null): ImageImageRepository
    {
        if (!$imageImageRepository) {
            $imageImageRepository = new ImageImageRepository();
        }

        $imageImageRepository->setRepository($this->imageRepository);
        $imageImageRepository->setStatus($this->status);

        return $imageImageRepository;
    }
}
